import { NormalizeState } from './util/definitions';
import { DenormalizeState } from './util/definitions';
import { Structure } from './util/definitions';
import { Entities } from './util/definitions';
import REMOVED_ENTITY from './util/RemovedEntity';
declare type Options<T> = {
    shape?: Structure<T>;
    id?: (entity: T) => string;
    merge?: (previous: T, next: T) => T;
};
export default class EntitySchema<T> {
    name: string;
    shape: Structure<T> | null;
    id: (value: T) => string;
    merge?: (previous: T, next: T) => T;
    constructor(name: string, options?: Options<T>);
    normalize(data: T, entities?: Entities): NormalizeState;
    denormalize(denormalizeState: DenormalizeState, path?: Array<any>): T | typeof REMOVED_ENTITY | null;
}
export {};
