import { NormalizeState, Structure } from './util/definitions';
import { DenormalizeState } from './util/definitions';
import { Entities } from './util/definitions';
import { Schema } from './util/definitions';
import { StructureOptions } from './util/definitions';
export default class ObjectSchema<T extends Record<string, unknown>> implements Structure<T> {
    create: (value: T) => T;
    merge: (previous: T, next: T) => T;
    relations: Partial<Record<keyof T, Schema<any>>>;
    constructor(relations: Partial<Record<keyof T, Schema<any>>>, options?: StructureOptions<T>);
    /**
     * ObjectSchema.normalize
     */
    normalize(data: T, entities?: Entities): NormalizeState;
    /**
     * ObjectSchema.denormalize
     */
    denormalize(denormalizeState: DenormalizeState, path?: Array<any>): T | null;
}
