export declare type Entities = Record<string, Record<string, unknown>>;
export declare type NormalizeState = {
    entities: Entities;
    result: any;
    schemas: Record<string, Schema<any>>;
};
export declare type DenormalizeState = {
    entities: Entities;
    result: any;
};
export interface Schema<T> {
    normalize: (data: T, entities: Entities) => NormalizeState;
    denormalize: (data: DenormalizeState, path?: Array<unknown>) => T | null;
}
export interface Entity<T, Shape> extends Schema<T> {
    name: string;
    id: (item: T) => string;
    shape: Shape | null;
}
export interface Structure<T> extends Schema<T> {
    /** @deprecated */
    create: (value: T) => T;
    merge: (previous: T, next: T) => T;
}
export declare type StructureOptions<T> = {
    create?: (value: T) => T;
    merge?: (previous: T, next: T) => T;
};
